"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
/**
 * Actualiza el elemento de la lista en caso de que exista en dicha lista, o lo inserta en caso de que no exista
 * @param element objeto que queremos actualizar o insertar en la lista
 * @param list lista de elementos
 */
function upsertElement(element, list) {
    var find = false;
    if (!list)
        list = [];
    list.forEach(function (item, index) {
        if (item.id == element.id) {
            list[index] = element;
            find = true;
        }
    });
    if (!find) {
        list.push(element);
    }
    return list;
}
exports.upsertElement = upsertElement;
/**
 * Elimina el elemento de la lista
 * @param element elemento a eliminar de la lista
 * @param list lista de elementos
 */
function deleteElement(element, list) {
    return list.filter(function (item) { return item.id != element.id; });
}
exports.deleteElement = deleteElement;
//# sourceMappingURL=utils.js.map