"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var core_2 = require("@angular/core");
var forms_1 = require("@angular/forms");
var ayuda_service_1 = require("../service/ayuda.service");
var general_utils_service_1 = require("../service/general-utils.service");
var forms_2 = require("@angular/forms");
var noop = function () { };
var ɵ0 = noop;
exports.ɵ0 = ɵ0;
exports.CUSTOM_INPUT_CONTROL_VALUE_ACCESSOR = {
    provide: forms_2.NG_VALUE_ACCESSOR,
    useExisting: core_1.forwardRef(function () { return BitInputComponent; }),
    multi: true
};
/** TODO: cambiar algunas propiedades que están en castellano como nombre, tipo al inglés: name, type
 * Clase que utiliza un custom componente para input text sencillos
 * Utiliza la interfaz ControlValueAccessor
 *    <bit-input2 [(ngModel)]="filter.fecha"
 *       [nombre]="'fecha2'" [control]="myForm.controls.fecha" formControlName="fecha" [tipo]="'date'" >&nbsp;&nbsp;fecha</bit-input2>
 *    <bit-input2 [(ngModel)]="filter.login"
 *       [nombre]="'login'" [control]="myForm.controls.login" formControlName="login" [tipo]="'text'" >&nbsp;&nbsp;login</bit-input2>
 **/
var BitInputComponent = /** @class */ (function () {
    function BitInputComponent(ayudaService, changeDetectorRef) {
        this.ayudaService = ayudaService;
        this.changeDetectorRef = changeDetectorRef;
        this.placeholder = "";
        this.readOnly = false;
        this.hideLabel = false; // forzar que no se reserve espacio para el nombre del campo
        this.disabled = false;
        this.completeMethod = new core_2.EventEmitter();
        this.onSelect = new core_2.EventEmitter();
        this.onChange = new core_2.EventEmitter();
        this.forceObligatorio = false;
        this.innerValue = "";
        this.onTouchedCallback = noop;
        this.onChangeCallback = noop;
        this.LOCALE_ES = {
            firstDayOfWeek: 1,
            closeText: "Cerrar",
            prevText: "<Ant",
            nextText: "Sig>",
            currentText: "Hoy",
            monthNames: [
                "enero",
                "febrero",
                "marzo",
                "abril",
                "mayo",
                "junio",
                "julio",
                "agosto",
                "septiembre",
                "octubre",
                "noviembre",
                "diciembre"
            ],
            monthNamesShort: [
                "ene",
                "feb",
                "mar",
                "abr",
                "may",
                "jun",
                "jul",
                "ago",
                "sep",
                "oct",
                "nov",
                "dic"
            ],
            dayNames: [
                "domingo",
                "lunes",
                "martes",
                "miércoles",
                "jueves",
                "viernes",
                "sábado"
            ],
            dayNamesShort: ["dom", "lun", "mar", "mié", "jue", "vie", "sáb"],
            dayNamesMin: ["D", "L", "M", "X", "J", "V", "S"],
            weekHeader: "Sm",
            dateFormat: "dd/mm/yy",
            firstDay: 1,
            isRTL: false,
            showMonthAfterYear: false,
            yearSuffix: "",
            timeOnlyTitle: "Elegir una hora",
            timeText: "Hora",
            hourText: "Horas",
            minuteText: "Minutos",
            secondText: "Segundos",
            millisecText: "Milisegundos",
            microsecText: "Microsegundos",
            timezoneText: "Uso horario",
            timeFormat: "HH:mm",
            timeSuffix: "",
            amNames: ["a.m.", "AM", "A"],
            pmNames: ["p.m.", "PM", "P"]
        };
    }
    Object.defineProperty(BitInputComponent.prototype, "value", {
        //get accessor
        get: function () {
            return this.innerValue;
        },
        //set accessor including call the onchange callback
        set: function (v) {
            if (this.tipo === "date") {
                //hacemos una reconversion de la fecha a formato corto. La versión final de Prime nos entrega el formato ISO
                //console.log("Valor para la fecha en formato largo {}",v);
                if (v) {
                    v = general_utils_service_1.GeneralUtils.getDateAsString(general_utils_service_1.GeneralUtils.stringToDate(v));
                }
                //console.log("Nuevo valor para la fecha {}",v);
            }
            if (this.tipo === "time") {
                //hacemos una reconversion de la fecha a formato corto. La versión final de Prime nos entrega el formato ISO
                //console.log("Valor para la fecha en formato largo {}",v);
                if (v) {
                    v = general_utils_service_1.GeneralUtils.getTimeAsString(general_utils_service_1.GeneralUtils.stringToDate(v));
                }
                //console.log("Nuevo valor para la fecha {}",v);
            }
            /*
            if (this.tipo === "datetime") {
              //hacemos una reconversion de la fecha a formato corto. La versión final de Prime nos entrega el formato ISO
              //console.log("Valor para la fecha en formato largo {}",v);
              if (v) {
                v = GeneralUtils.getDateTimeAsString(v);
              }
              //console.log("Nuevo valor para la fecha {}",v);
            }
            */
            if (v !== this.innerValue) {
                this.innerValue = v;
            }
            this.onChangeCallback(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(BitInputComponent.prototype, "value_lectura", {
        get: function () {
            if (this.value == null) {
                return "";
            } // si es null o undefined (es lo que evalúa el "==null")
            else if (this.tipo === "lectura-date") {
                return general_utils_service_1.GeneralUtils.getDateAsString(general_utils_service_1.GeneralUtils.stringToDate(this.value));
            } // valor en formato ISO
            else if (this.tipo === "lectura-time") {
                return general_utils_service_1.GeneralUtils.getTimeAsString(general_utils_service_1.GeneralUtils.stringToDate(this.value));
            } // valor en formato ISO
            else if (this.tipo === "lectura-datetime" || this.tipo === "datetime") {
                return general_utils_service_1.GeneralUtils.getDateTimeAsString(general_utils_service_1.GeneralUtils.stringToDate(this.value));
            } // valor en formato ISO
            else if (this.value === true) {
                return "Sí";
            }
            else if (this.value === false) {
                return "No";
            }
            else {
                return this.value;
            }
        },
        enumerable: true,
        configurable: true
    });
    BitInputComponent.prototype.changed = function (event) {
        this.onTouchedCallback();
        this.onChangeCallback(this.innerValue);
        this.onChange.emit(event);
    };
    BitInputComponent.prototype.onBlur = function () {
        if (this.instanciaPipe != null) {
            this.innerValue = this.instanciaPipe.transform(this.innerValue);
        }
        this.onTouchedCallback();
    };
    BitInputComponent.prototype.onFocus = function () {
        if (this.instanciaPipe != null) {
            this.innerValue = this.instanciaPipe.parse(this.innerValue);
            this.control.updateValueAndValidity();
        }
        this.onTouchedCallback();
        // this.onChangeCallback(this.innerValue);
    };
    BitInputComponent.prototype.writeValue = function (value) {
        if (value !== this.innerValue) {
            this.innerValue = value;
            // hack para que el ControlValueAccesor funcione correctamente cuando está referenciado en componentes con ChangeDetectionStrategy.OnPush
            // (no es nada bonito, pero Angular lleva 2 años con este bug y no lo han solucionado)
            // si no lo incluimos, en algunos casos se corre el riesgo de ir varios valores por detrás en el bit-input
            this.changeDetectorRef.markForCheck();
        }
    };
    BitInputComponent.prototype.registerOnChange = function (fn) {
        this.onChangeCallback = fn;
    };
    BitInputComponent.prototype.registerOnTouched = function (fn) {
        this.onTouchedCallback = fn;
    };
    BitInputComponent.prototype.search = function (event) {
        this.completeMethod.emit(event);
    };
    BitInputComponent.prototype.selectValue = function (event) {
        this.onSelect.emit(event);
    };
    Object.defineProperty(BitInputComponent.prototype, "obligatorio", {
        // decidimos marcar el campo como obligatorio si se ha indicado a la fuerza (por parámetro)
        // o si el control de formulario asociado está saltando por ser obligatorio y no haberse rellenado
        get: function () {
            return (this.forceObligatorio ||
                (this.control && this.control.errors && this.control.errors["required"]));
        },
        enumerable: true,
        configurable: true
    });
    BitInputComponent.prototype.showAyuda = function () {
        this.ayudaService.mostrarAyuda(this.ayuda);
    };
    BitInputComponent.prototype.setDisabledState = function (isDisabled) {
        this.disabled = isDisabled;
    };
    Object.defineProperty(BitInputComponent.prototype, "modoLecturaSimple", {
        get: function () {
            // tipo "lectura*", o readOnly no textarea
            return ((this.tipo && this.tipo.startsWith("lectura")) ||
                (this.readOnly && this.tipo !== "textarea"));
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(BitInputComponent.prototype, "modoLecturaMultilinea", {
        get: function () {
            return this.tipo && this.tipo === "textarea" && this.readOnly;
        },
        enumerable: true,
        configurable: true
    });
    __decorate([
        core_2.Input(),
        __metadata("design:type", forms_1.FormControl)
    ], BitInputComponent.prototype, "control", void 0);
    __decorate([
        core_2.Input(),
        __metadata("design:type", Object)
    ], BitInputComponent.prototype, "nombre", void 0);
    __decorate([
        core_2.Input(),
        __metadata("design:type", Object)
    ], BitInputComponent.prototype, "nombreDirectiva", void 0);
    __decorate([
        core_2.Input(),
        __metadata("design:type", String)
    ], BitInputComponent.prototype, "label", void 0);
    __decorate([
        core_2.Input(),
        __metadata("design:type", String)
    ], BitInputComponent.prototype, "tipo", void 0);
    __decorate([
        core_2.Input(),
        __metadata("design:type", String)
    ], BitInputComponent.prototype, "estilo", void 0);
    __decorate([
        core_2.Input(),
        __metadata("design:type", String)
    ], BitInputComponent.prototype, "tooltiptexto", void 0);
    __decorate([
        core_2.Input(),
        __metadata("design:type", String)
    ], BitInputComponent.prototype, "tooltipposicion", void 0);
    __decorate([
        core_2.Input(),
        __metadata("design:type", String)
    ], BitInputComponent.prototype, "ayuda", void 0);
    __decorate([
        core_2.Input(),
        __metadata("design:type", Array)
    ], BitInputComponent.prototype, "suggestions", void 0);
    __decorate([
        core_2.Input(),
        __metadata("design:type", String)
    ], BitInputComponent.prototype, "suggestionField", void 0);
    __decorate([
        core_2.Input(),
        __metadata("design:type", String)
    ], BitInputComponent.prototype, "placeholder", void 0);
    __decorate([
        core_2.Input(),
        __metadata("design:type", Boolean)
    ], BitInputComponent.prototype, "readOnly", void 0);
    __decorate([
        core_2.Input(),
        __metadata("design:type", Boolean)
    ], BitInputComponent.prototype, "hideLabel", void 0);
    __decorate([
        core_2.Input(),
        __metadata("design:type", Boolean)
    ], BitInputComponent.prototype, "disabled", void 0);
    __decorate([
        core_2.Input(),
        __metadata("design:type", Object)
    ], BitInputComponent.prototype, "valueRadioButton", void 0);
    __decorate([
        core_2.Input(),
        __metadata("design:type", Date)
    ], BitInputComponent.prototype, "fechaMinima", void 0);
    __decorate([
        core_2.Input(),
        __metadata("design:type", Date)
    ], BitInputComponent.prototype, "fechaMaxima", void 0);
    __decorate([
        core_2.Input(),
        __metadata("design:type", Boolean)
    ], BitInputComponent.prototype, "calendarReadOnlyInput", void 0);
    __decorate([
        core_2.Input(),
        __metadata("design:type", Object)
    ], BitInputComponent.prototype, "instanciaPipe", void 0);
    __decorate([
        core_2.Output(),
        __metadata("design:type", Object)
    ], BitInputComponent.prototype, "completeMethod", void 0);
    __decorate([
        core_2.Output(),
        __metadata("design:type", Object)
    ], BitInputComponent.prototype, "onSelect", void 0);
    __decorate([
        core_2.Output(),
        __metadata("design:type", Object)
    ], BitInputComponent.prototype, "onChange", void 0);
    __decorate([
        core_2.Input(),
        __metadata("design:type", Boolean)
    ], BitInputComponent.prototype, "forceObligatorio", void 0);
    BitInputComponent = __decorate([
        core_1.Component({
            selector: "bit-input",
            template: "\n            <label *ngIf=\"!hideLabel && tipo!='checkbox' && tipo!='oculto'\"><ng-content></ng-content>&nbsp;<span *ngIf=\"obligatorio\" class=\"obligatorio fa fa-asterisk\"></span>&nbsp;&nbsp;<i *ngIf=\"ayuda\" class=\"btn-ayuda fa fa-question\" (click)=\"showAyuda();\"></i></label>\n            <p *ngIf=\"modoLecturaSimple\" class=\"lectura\" [id]=\"nombre\">{{value_lectura}}</p>\n            <pre *ngIf=\"modoLecturaMultilinea\" class=\"lectura\" [id]=\"nombre\">{{value_lectura}}</pre>\n           \n            <input *ngIf=\"tipo=='text' && !tooltiptexto && !readOnly\" \n                    type=\"text\" class=\"form-control\" [(ngModel)]=\"value\"  id=\"{{nombre}}\" name=\"{{nombre}}\"\n                    (ngModelChange)=\"changed($event)\"\n                    [attr.directive]=\"nombreDirectiva\" (blur)=\"onBlur()\" (focus)=\"onFocus()\"\n                    [placeholder]=\"placeholder\" />\n            <input *ngIf=\"tipo=='text' && tooltiptexto && !readOnly\" \n                    type=\"text\" class=\"form-control\" [(ngModel)]=\"value\"  id=\"{{nombre}}\" name=\"{{nombre}}\" \n                    (ngModelChange)=\"changed($event)\"\n                    [attr.directive]=\"nombreDirectiva\" (blur)=\"onBlur()\" (focus)=\"onFocus()\" [pTooltip]=\"tooltiptexto\" [tooltipPosition]=\"tooltipposicion\" />\n            <input *ngIf=\"tipo=='oculto' && !readOnly\"\n                    type=\"hidden\" [(ngModel)]=\"value\"  id=\"{{nombre}}\" name=\"{{nombre}}\" \n                    (ngModelChange)=\"changed($event)\"\n                    [attr.directive]=\"nombreDirectiva\" />\n            <textarea pInputTextarea *ngIf=\"tipo=='textarea' && !readOnly\" class=\"form-control h-100 {{estilo}}\" [(ngModel)]=\"value\" id=\"{{nombre}}\" name=\"{{nombre}}\"\n                    (ngModelChange)=\"changed($event)\"\n                    (blur)=\"onBlur()\" (focus)=\"onFocus()\"></textarea>\n            <p-checkbox class=\"{{estilo}}\" \n\t    \t\t*ngIf=\"tipo=='checkbox' && !readOnly\" binary=\"true\"\n\t\t\t[(ngModel)]=\"value\" \n                        (ngModelChange)=\"changed($event)\"\n\t\t\t[label]=\"!hideLabel && label\" \n\t\t\tname=\"{{nombre}}\" \n\t\t\tid=\"{{nombre}}\"\n\t\t\t[disabled]=\"disabled\"\n\t    ></p-checkbox>\n            <i *ngIf=\"ayuda && tipo=='checkbox' && !readOnly\" (click)=\"showAyuda();\"class=\"btn-ayuda-checkbox fa fa-question\"></i>\n            <p-radioButton  class=\"{{estilo}}\" *ngIf=\"tipo=='radiobutton' && !readOnly\" binary=\"true\" [(ngModel)]=\"value\" [label]=\"!hideLabel && label\" name=\"{{nombre}}\" value=\"{{valueRadioButton}}\" id=\"{{nombre}}\"\n                    (ngModelChange)=\"changed($event)\" [disabled]=\"disabled\"></p-radioButton>\n\n            <p-calendar *ngIf=\"tipo=='date' && !readOnly\" class=\"FormControl\" [(ngModel)]=\"value\" id=\"{{nombre}}\" name=\"{{nombre}}\"                        \n                    (ngModelChange)=\"changed($event)\"\n                    dateFormat=\"dd/mm/yy\" placeholder=\"dd/mm/yyyy\" [monthNavigator]=\"true\" [readonlyInput]=\"calendarReadOnlyInput\"\n                    [minDate]=\"fechaMinima\" [maxDate]=\"fechaMaxima\"\n                    [yearNavigator]=\"true\" yearRange=\"2000:2030\" [locale]=\"LOCALE_ES\"></p-calendar>\n            <p-calendar *ngIf=\"tipo=='datetime' && !readOnly\" class=\"FormControl\" [(ngModel)]=\"value\" id=\"{{nombre}}\" name=\"{{nombre}}\"                        \n                    (ngModelChange)=\"changed($event)\"\n                    dateFormat=\"dd/mm/yy\" placeholder=\"dd/mm/yyyy hh:mm\" [monthNavigator]=\"true\"\n                    [minDate]=\"fechaMinima\" [maxDate]=\"fechaMaxima\"\n                    [yearNavigator]=\"true\" yearRange=\"2000:2030\" [locale]=\"LOCALE_ES\" [showTime]=\"true\"></p-calendar>\n            <span *ngIf=\"tipo=='date' && !readOnly\" class=\"glyphicon glyphicon-calendar icono-input\"></span>\n            <span *ngIf=\"tipo=='datetime' && !readOnly\" class=\"glyphicon glyphicon-calendar icono-input\"></span>\n            <p-calendar *ngIf=\"tipo=='time' && !readOnly\" class=\"FormControl\" [(ngModel)]=\"value\"   id=\"{{nombre}}\" name=\"{{nombre}}\"                        \n                    (ngModelChange)=\"changed($event)\"\n                    timeFormat=\"HH:mm\" [timeOnly]=\"true\" placeholder=\"HH:mm\" [locale]=\"LOCALE_ES\"></p-calendar>\n            <p-autoComplete *ngIf=\"tipo=='autocomplete' && !readOnly\" \n                    [(ngModel)]=\"value\" \n                    id=\"{{nombre}}\" \n                    name=\"{{nombre}}\" \n                    [placeholder]=\"placeholder\"\n                    (ngModelChange)=\"changed($event)\"\n\t\t    delay=\"400\" \n                    [immutable]=\"false\"\n                    [suggestions]=\"suggestions\" \n                    [field]=\"suggestionField\" \n                    (completeMethod)=\"search($event)\" \n                    (onSelect)=\"selectValue($event)\" \n                    (blur)=\"onBlur()\" \n                    (focus)=\"onFocus()\" \n                    [multiple]=\"multiple\"\n            ></p-autoComplete>\n            <p-inputSwitch *ngIf=\"tipo=='switch' && !readOnly\" onLabel=\"S\u00ED\" offLabel=\"No\" binary=\"true\" [(ngModel)]=\"value\" (ngModelChange)=\"changed($event)\" name=\"{{nombre}}\" id=\"{{nombre}}\"></p-inputSwitch>\n            <control-messages *ngIf=\"control!=null && !readOnly\" [control]=\"control\" [field]=\"nombre\"></control-messages>\n",
            providers: [exports.CUSTOM_INPUT_CONTROL_VALUE_ACCESSOR]
        }),
        __metadata("design:paramtypes", [ayuda_service_1.AyudaService,
            core_1.ChangeDetectorRef])
    ], BitInputComponent);
    return BitInputComponent;
}());
exports.BitInputComponent = BitInputComponent;
//# sourceMappingURL=bit-input.component.js.map